#include "fc.h"
#include "fca-mgr.h"
#include "fca-pkt.h"


static class FCARcvrClass : public TclClass {
public:
    FCARcvrClass() : TclClass("FCARcvr") { }
    ~FCARcvrClass() { }
    TclObject *create(int /*argc*/, const char*const* /*argv*/) {
	return new FCARcvr;
    }
} fcaRcvrClass;


void 
FCARcvr::recv(u_char *pb, int len)
{
    Debug(dbgFCA, ("Received %d bytes from the network:", len));
    static char buffer[10000];
    *buffer = '\0';
    for (int i=0; i<len; i++) {
	sprintf(buffer, "%s%02x ", buffer, pb[i]);
    }
    Debug(dbgFCA, ("%s", buffer));

    FCA_Packet *pkt = FCA_Packet::New();
    if (pkt->Extract(pb, len)==FALSE) return;
    Tcl::instance().evalf("%s recv %s", name(), pkt->name());
    FCA_Packet::Delete(pkt);
}
