#include <tcl.h>
#include "mash-event.h"
#include "vidreps.h"
/*
 * This is a version of "vwait forever" that handle Mash/Degas Events.
 * Based on Tcl_VwaitCmd in tclEvent.c
 */

int Mash_DoOneEvent();

#define TCL_WFT_EVENTS TCL_WINDOW_EVENTS | TCL_FILE_EVENTS | TCL_TIMER_EVENTS

int 
Mash_RunCmd (ClientData cd, Tcl_Interp *interp, int argc, char *argv[])
{
    int foundEvent;

    if (argc != 1) {
        Tcl_AppendResult(interp, "wrong # args: should be \"",argv[0], " \"",
            (char *)NULL);
        return TCL_ERROR;
    }
    foundEvent = 0;
    while (1) {
	if (!foundEvent) {
	    Tcl_DoOneEvent ( TCL_ALL_EVENTS );
	} else {
	    Tcl_DoOneEvent ( TCL_WFT_EVENTS | TCL_DONT_WAIT);
	}
	foundEvent = Mash_DoOneEvent();
    }
    return TCL_OK;
}

int
Mash_DoOneEvent()
{
    Mash_QueueEvent *event;
    event = Mash_RemoveFromEventQueue ();
    if (event) {
	fprintf(stderr, "%s\n", ((Uncompressed *)(event->buffer))->source_id_);
        (event->obj)->recv(event->buffer);
	return 1;
    } else {
	return 0;
    }
}
