#include "mc/session-mc.h"
#include "mc/pend-mc.h"
#include "mc/common-mc.h"
#include <limits.h>

static class MCSessionTclClass : public TclClass {
public:
	MCSessionTclClass() : TclClass("Session/SRM/MC") {}
	
	TclObject* create(int argc, const char*const* /*argv*/) {
		if (argc==4) {
			return (new MC_Session());
		} else {
			return (TclObject*)NULL;
		}
	}
} mcsession_class;

void
MC_Session::sched_pending(MC_Pending *mp, const srm_src& p_tgt) 
{
//	mp->set_source(sm_->first_local_source()->id());

	struct srm_src src;
	mp->set_source(src);
	mp->set_tgt(p_tgt);
	mp->msched((int)pending_time(p_tgt));
}
/* 
 * Returns a random time to wait before send out the reply, note that
 * this does not include the backoff multiplier 
 */
double
MC_Session::pending_time(const srm_src& p_tgt)
{
	double delay = delay_est(p_tgt);
	if (delay == 0.0)       delay = min_pending_;
	if (delay < min_delay_) delay = min_delay_;
	double rand = (double)random()/double(INT_MAX);
	double waitTime = delay*(e1_ + e2_*rand);
	return waitTime;
}

