/*
 * Copyright (c) @ Regents of the University of California.
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 * 	This product includes software developed by the MASH Research
 * 	Group at the University of California Berkeley.
 * 4. Neither the name of the University nor of the Research Group may be
 *    used to endorse or promote products derived from this software without
 *    specific prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * @(#) $Header: /usr/src/mash/repository/mash/mash-1/smash-main.cc,v 1.2 1999/01/18 22:09:38 weitsang Exp $
 */


#include <tcl.h>
#include <tclcl.h>
#include "rate-variable.h"
#include "mash-init.h"
#ifdef HAVE_SRMV2_API_H
#include "srmv2-api.h"
#endif
#ifdef HAVE_JPEGWC_H
#include "jpegwc.h"
#endif

#ifdef __PSVP_ENABLED__
extern int Psvp_Init(Tcl_Interp *interp);
#endif

/*
 *----------------------------------------------------------------------
 *
 * main --
 *
 *	This is the main program for the application.
 *
 * Results:
 *	None: Tk_Main never returns here, so this procedure never
 *	returns either.
 *
 * Side effects:
 *	Whatever the application does.
 *
 *----------------------------------------------------------------------
 */

int
main(int argc, char** argv)
{
        Tcl_Main(argc, argv, Smash_AppInit);
        return 0; 
}


int
Smash_AppInit(Tcl_Interp *interp)
{
	if (Tcl_Init(interp) == TCL_ERROR) {
		WIN32_OutputErr(interp, "Tcl_Init failed!");
		return TCL_ERROR;
	}
	if (Otcl_Init(interp) == TCL_ERROR) {
		WIN32_OutputErr(interp, "Otcl_Init failed!");
		return TCL_ERROR;
	}

	if (Mash_TclInit(interp) == TCL_ERROR) {
		WIN32_OutputErr(interp, "Mash_TclInit failed!");
		return TCL_ERROR;
	}
	
	/* XXX: must move this to Mash_TclInit once we get rid of the
	 * Tcl-only files from et_tk
	 */
//#ifdef notdef
	extern EmbeddedTcl et_tcl;
	et_tcl.load();
//#endif

	return TCL_OK;	
}
