import RTPApplication
import AnnounceListenManager/GraphComm

Class GraphCommMonitor -superclass RTPApplication

GraphCommMonitor instproc init args {

    $self next graph_comm_monitor

    $self init_resources;

    $self instvar comm_obj_list_;

    set comm_obj_list_ "";
}

GraphCommMonitor instproc add_spec {spec} {
    $self instvar comm_obj_list_;
    
    set new_comm_obj [new AnnounceListenManager/GraphComm [$self get_option mtu] $spec];
    $new_comm_obj register [$self get_option comm_id] "$self recv_graph_comm $spec ";
    
    lappend comm_obj_list_ $new_comm_obj;
}

GraphCommMonitor instproc recv_graph_comm {spec rid mesg} {
    puts "On channel $spec (ref. $rid) ---> $mesg";
}

GraphCommMonitor instproc init_resources {} {
    $self add_option network ip
    $self add_option mtu 1024
    $self add_option defaultTTL 32
    $self add_option sessionType rtpv2
    $self add_option maxVideoSessionBW 30000000
    $self add_option comm_id m1
}

GraphCommMonitor instproc send_mesg {cobj mesg} {
    
    $cobj do_announce [$self get_option comm_id] -1 $mesg;
}


set app [new GraphCommMonitor $argv];





