import RTPApplication
import AnnounceListenManager/GraphComm
import RTCPAgent
import SourceListMenu

proc HandleRequest {sfd addr port} {
    global client_sock_fd;

    set client_sock_fd $sfd;
}

proc StartProc {mash_bin tdemo_client my_addr my_port cmd args} {
    global client_sock_fd;
    
    set client_sock_fd "";
    
#    puts "Starting $cmd $args";
    flush stdout;
    
#    eval exec glurun $mash_bin $tdemo_client -- $my_addr $my_port $cmd $args &;
    # eval exec glurun $mash_bin $tdemo_client  $my_addr $my_port $cmd $args >& /dev/null &;
    eval exec glurun $mash_bin $tdemo_client  $my_addr $my_port $cmd $args  &;
    
    while {$client_sock_fd == ""} {
	update;
    }
    
    set client_host [gets $client_sock_fd];
    
#    puts "Client started on $client_host";
    
    global env node_spec;
    
    set node_spec "${node_spec}-${client_host}";
    set env(GLUNIX_NODES) $node_spec;
    
    set client_sock_fd "";
}

Class FadeDemo -superclass RTPApplication

FadeDemo instproc init args {
    global env;

    $self next psvp_demo;

    $self instvar ready_flag_;

    set ready_flag_ 0;

    $self init_resources;

    [$self options] register_option -cntrl_spec cntrl_spec
    [$self options] register_option -comm_id comm_id
    [$self options] register_option -source_session_a source_session_a
    [$self options] register_option -source_session_b source_session_b
    [$self options] register_option -dest_session dest_session
    [$self options] register_option -num_nodes num_nodes;
    [$self options] register_option -subprogram subprogram;

    eval [$self options] parse_args $args;
    
    set mash_dir $env(HOME)/mash-1-now/mash-1;
    set mash_bin $mash_dir/bin/smash;
    set tselect $mash_dir/tcl/psvp/test/tselect.tcl
    set tinter $mash_dir/tcl/psvp/test/tinter.tcl
    set tproc $mash_dir/tcl/psvp/test/tproc.tcl
    set tdemo_client $mash_dir/tcl/psvp/test/tdemo-client.tcl

    set env(TCLCL_IMPORT) $env(HOME)/mash-1-now/mash-1:$env(HOME)/mash-1-now/mash-1/psvp/tcl:$env(HOME)/mash-1-now/mash-1/psvp/effects

    cd $mash_dir;

    set port 30111;

    global node_spec
    set node_spec all;

    set hname [exec hostname];
    set habbr [lindex [split [string trim $hname] .] 0];
    set env(GLUNIX_NODES) "${node_spec}-${habbr}";
    
    set server_fd [socket -server HandleRequest $port]

    set cntrl_spec [$self get_option cntrl_spec];
    set subprogram [$self get_option subprogram];

    StartProc $mash_bin $tdemo_client $hname $port $tselect -cntrl_spec $cntrl_spec -comm_id ts;
#    StartProc $mash_bin $tdemo_client $hname $port $tinter -cntrl_spec $cntrl_spec -comm_id ti;
    for {set i 0} {$i < [$self get_option num_nodes]} {incr i} {
	StartProc $mash_bin $tdemo_client $hname $port $tproc -reg_comm_spec $cntrl_spec -subprogram $subprogram
    }

#    set now [clock clicks];
#    while {[expr [clock clicks] - $now] < 2000000} {
#    }

    puts "All started";

    $self instvar cntrl_obj_;

    set cntrl_obj_ [new AnnounceListenManager/GraphComm [$self get_option mtu] [$self get_option cntrl_spec]];

    $cntrl_obj_ register [$self get_option comm_id] "$self recv_graph_comm";

    frame .param_frame;

    pack .param_frame -side top  -fill both -expand 1

    label .param_frame.l -text "Parameters"

    pack .param_frame.l -side top -fill both -expand 1

    button .start -text "Start" -command "$self DoStart";
    pack .start -side top -fill both -expand 1;

    button .quit -text "Quit" -command "exit";
    pack .quit -side bottom -fill both -expand 1;
    
    set input_id_request [$self send_graph_comm -1 "query_input_ids" 100];
    $self set callback_array_($input_id_request) "$self BuildInputFrame $input_id_request "

    set output_id_request [$self send_graph_comm -1 "query_output_ids" 100]
    $self set callback_array_($output_id_request) "$self BuildOutputFrame $output_id_request " 

    set param_id_request [$self send_graph_comm -1 "query_parameter_ids" 100]
    $self set callback_array_($param_id_request) "$self BuildParamFrame $param_id_request "
}

FadeDemo instproc send_graph_comm {rid mesg {resend_period 0} {deliver_once_flag 0}} {
    $self instvar cntrl_obj_;

    set comm_id [$self get_option comm_id];

    return [$cntrl_obj_ do_announce $comm_id $rid $mesg $resend_period $deliver_once_flag];
}

FadeDemo instproc recv_graph_comm {rid mesg} {
    $self instvar input_id_request_;
    $self instvar callback_array_;

    if {[info exists callback_array_($rid)]} {
	eval $callback_array_($rid) [list $mesg];
	unset callback_array_($rid);
    }
}

FadeDemo instproc BuildInputFrame {req_id reply} {
    $self instvar cntrl_obj_ rtcp_agent_;

    $cntrl_obj_ stop_resend $req_id;

    set in_list [lindex $reply 1];
    
    set session_spec(0) [$self get_option source_session_a];
    set session_spec(1) [$self get_option source_session_b];

    set cntr 0;

    $self instvar trigger_input_id_;
    
    foreach id $in_list {
	$self send_graph_comm -1 [list set_input_spec $id $session_spec($cntr)/*] 1000 1;
	incr cntr;
    }
    set trigger_input_id_ [lindex $in_list 0];

    $self CheckReady;
}

FadeDemo instproc CheckReady {} {
    $self instvar ready_flag_;
    incr ready_flag_;
    if {$ready_flag_ == 3} {
	.start configure -state normal;
    }
}

FadeDemo instproc BuildOutputFrame {req_id reply} {
    $self instvar cntrl_obj_;

    $cntrl_obj_ stop_resend $req_id;

    set out_list [lindex $reply 1];
    foreach id $out_list {
	$self send_graph_comm -1 [list set_output_spec $id [$self get_option dest_session]] 1000 1;
    }

    $self CheckReady;
}

FadeDemo instproc BuildParamFrame {req_id reply} {

    $self instvar cntrl_obj_;

    $cntrl_obj_ stop_resend $req_id;

    set param_list [lindex $reply 1];
	
    foreach id $param_list {
	set param_info_request [$self send_graph_comm -1 [list query_parameter_info $id]];
	$self set callback_array_($param_info_request) "$self BuildParam $param_info_request ";
    }
    $self CheckReady;
}

FadeDemo instproc BuildParam {req_id reply} {
    $self instvar cntrl_obj_;

    $cntrl_obj_ stop_resend $req_id;

    set id [lindex $reply 1];
    set pinfo [lindex $reply 2];

    set ptype "";
    set pdomain "";
    set pvalue "";

    foreach entry $pinfo {
	set e_type [lindex $entry 0];
	set e_val [lindex $entry 1];

	if {$e_type == "type"} {
	    set ptype $e_val;
	} elseif {$e_type == "domain"} {
	    set pdomain $e_val;
	} elseif {$e_type == "value"} {
	    set pvalue $e_val;
	}
    }

    set f [frame .param_frame.$id];
    label $f.l -text "$id";
    pack $f.l -side left;

    if {$ptype == "real"} {
	# Handle real value parameters here.
	set pdomain [split $pdomain "(),"];
	set from [lindex $pdomain 1];
	set to [lindex $pdomain 2];

	scale $f.s -from $from -to $to -resolution [expr ($to - $from)/100.0] -orient h;
	$f.s set $pvalue;
	pack $f.s -side right -fill x -expand 1;
	$f.s configure -command "$self send_graph_comm -1 \[list set_parameter $id \[$f.s get\]\]; #";
    } elseif {$ptype == "int"} {
	# Handle int value parameter here.
	set pdomain [split $pdomain "(),"];
	set from [lindex $pdomain 1];
	set to [lindex $pdomain 2];
	
	scale $f.s -from $from -to $to -resolution 1 -orient h;
	$f.s set $pvalue;
	pack $f.s -side right -fill x -expand 1;
	$f.s configure -command "$self send_graph_comm -1 \[list set_parameter $id \[$f.s get\]\]; #";
    } else {
	# All other types
	entry $f.e;
	button $f.b -text "Set" -command "$self send_graph_comm -1 \[list set_parameter $id \[$f.e get\]\]";
	pack $f.e -side left -fill x -expand 1;
	pack $f.b -side right;
	$f.e insert 0 $e_val;
    }

    pack $f -side top -fill both -expand 1;
}


FadeDemo instproc DoStart {} {
    $self instvar trigger_input_id_;

    $self send_graph_comm -1 [list set_input_trigger $trigger_input_id_ 1];

    .start configure -text "Stop" -command "$self DoStop";
}

FadeDemo instproc DoStop {} {
    $self instvar trigger_input_id_;

    $self send_graph_comm -1 [list set_input_trigger $trigger_input_id_ 0];

    .start configure -text "Start" -command "$self DoStart";
}
    

FadeDemo instproc init_resources {} {
    $self add_option network ip
    $self add_option mtu 1024
    $self add_option defaultTTL 63
    $self add_option sessionType rtpv2
    $self add_option maxVideoSessionBW 30000000
    $self add_option cntrl_spec 224.3.2.1/22334/16
    $self add_option comm_id ui;
    $self add_option source_session_a 239.255.124.168/49256
    $self add_option source_session_b 224.2.3.4/22334
    $self add_option dest_session 224.2.3.5/22334
    $self add_option num_nodes 3;
    $self add_option subprogram ScFadeSubprogram
}

set app [new FadeDemo $argv];

