import RTPApplication
import TemporalSelector

Class TSelectApp -superclass RTPApplication

TSelectApp instproc init args {
    $self next tselect_app

    $self init_resources;

    [$self options] register_option -comm_id comm_id
    [$self options] register_option -cntrl_spec cntrl_spec

    eval [$self options] parse_args $args;

    $self instvar tselect_obj_
    
    set tselect_obj_ [new TemporalSelector [$self get_option comm_id] [$self get_option cntrl_spec]];

#    label .trigger;
#    label .token;
#    label .fire;

#    pack .trigger;
#    pack .token;
#    pack .fire;

#    $self UpdateLabels;
}

TSelectApp instproc UpdateLabels {} {
    $self instvar tselect_obj_;

    set p [$tselect_obj_ set token_rate_period_];
    set tcount [$tselect_obj_ set trigger_count_];
    set fcount [$tselect_obj_ set fire_count_];
    set tok_count [$tselect_obj_ set ctoken_count_];

    .trigger configure -text "[expr $tcount * 1000.0 / $p]";
    .token configure -text "[expr $tok_count * 1000.0 / $p]";
    .fire configure -text "[expr $fcount * 1000.0 / $p]";

    after $p $self UpdateLabels;
}

TSelectApp instproc init_resources {} {
    $self add_option network ip
    $self add_option mtu 1024
    $self add_option defaultTTL 32
    $self add_option sessionType rtpv2
    $self add_option maxVideoSessionBW 30000000
    $self add_option comm_id ts
    $self add_option cntrl_spec 224.3.2.1/22334/16
}

set app [new TSelectApp $argv];

puts "Selector running on [exec hostname]";

vwait forever;
